## Controller_OS.tar.gz

=== ak4637-mod/Makefile ===
obj-m := snd-soc-ak4637.o

ccflags-y := -I$(src)/include
snd-soc-ak4637-y := ak4637.o

SRC := $(shell pwd)

all:
	$(MAKE) -C $(KERNEL_SRC) M=$(SRC)

modules_install:
	$(MAKE) -C $(KERNEL_SRC) M=$(SRC) modules_install

clean:
	rm -f *.o *~ core .depend .*.cmd *.ko *.mod.c
	rm -f Module.markers Module.symvers modules.order
	rm -rf .tmp_versions Modules.symvers
