=== nfc-mod/Makefile ===
#******************************************************************************
#* Copyright (C) 2016 Ricoh Company, Ltd.  All Rights Reserved.
#*
#*****************************************************************************/
#
#
# cross-compile module makefile

obj-m := nfc.o
nfc-objs := nfc_core.o am.o

SRC := $(shell pwd)

all:
	echo "make nfc kernel object"
	echo $(KERNEL_SRC) 
	$(MAKE) -C $(KERNEL_SRC) M=$(SRC)

modules_install:
	echo "install nfc.ko"
	echo $(KERNEL_SRC) 
	$(MAKE) -C $(KERNEL_SRC) M=$(SRC) modules_install

ext:
	$(MAKE) -f makefile-external

indent: nfc_core.c am.c nfc.h am.h
	indent -nbad -bap -nbc -bbo -hnl -br -brs -c33 -cd33 -ncdb -ce -ci4 -cli0 -d0 -di1 -nfc1 -i8 -ip0 -l80 -lp -npcs -nprs -npsl -sai -saf -saw -ncs -nsc -sob -nfca -cp33 -ss -ts8 -il1 nfc_core.c
	indent -nbad -bap -nbc -bbo -hnl -br -brs -c33 -cd33 -ncdb -ce -ci4 -cli0 -d0 -di1 -nfc1 -i8 -ip0 -l80 -lp -npcs -nprs -npsl -sai -saf -saw -ncs -nsc -sob -nfca -cp33 -ss -ts8 -il1 am.c
	indent -nbad -bap -nbc -bbo -hnl -br -brs -c33 -cd33 -ncdb -ce -ci4 -cli0 -d0 -di1 -nfc1 -i8 -ip0 -l80 -lp -npcs -nprs -npsl -sai -saf -saw -ncs -nsc -sob -nfca -cp33 -ss -ts8 -il1 nfc.h
	indent -nbad -bap -nbc -bbo -hnl -br -brs -c33 -cd33 -ncdb -ce -ci4 -cli0 -d0 -di1 -nfc1 -i8 -ip0 -l80 -lp -npcs -nprs -npsl -sai -saf -saw -ncs -nsc -sob -nfca -cp33 -ss -ts8 -il1 am.h

clean:
	(cd sample; make clean)
	rm -f *.o *~ core .depend .*.cmd *.ko *.mod.c
	rm -f Module.markers Module.symvers modules.order
	rm -rf .tmp_versions Modules.symvers
