=== notice-mod/Makefile ===
#
# ============================================================================
# Copyright (c) 2015 RICOH Company, Ltd. All Rights Reserved
#
# ============================================================================
#

ccflags-y := -I$(src)/include
obj-m := notice.o
notice-objs := notice_core.o
