=== svinput-mod/Makefile ===
#
# ============================================================================
# Copyright (c) 2015 RICOH Company, Ltd. All Rights Reserved
#
# ============================================================================
#

ccflags-y := -I$(src)/include
obj-m := svinput.o
svinput-objs := svinput_core.o sv_touchpanel.o sv_keyboard.o sv_led.o sv_backlight.o sv_touchpanel.o sv_power.o
