=== usbmix-mod/Makefile ===
#
# ============================================================================
# Copyright (c) 2015 RICOH Company, Ltd. All Rights Reserved
#
# ============================================================================
#

ccflags-y := -I$(src)/include
obj-m := usbmix.o
usbmix-objs := usb.o generic.o initializers.o protocol.o scsiglue.o transport.o usb-serial.o usbnet.o cdc_ether.o bus.o usbmix_desc.o
