=== netbase/debian/control ===
Source: netbase
Section: admin
Priority: important
Maintainer: Marco d'Itri <md@linux.it>
Standards-Version: 3.9.4.0
Build-Depends: debhelper (>= 7)
Vcs-Git: git://git.debian.org/users/md/netbase.git
Vcs-Browser: http://git.debian.org/?p=users/md/netbase.git

Package: netbase
Architecture: all
Multi-Arch: foreign
Depends: lsb-base (>= 3.0-6), ${misc:Depends}
Conflicts: openbsd-inetd (<< 0.20050402-3), inetutils-inetd (<< 2:1.4.3+20060719-3)
Breaks: ifupdown (<< 0.7)
Recommends: ifupdown
Description: Basic TCP/IP networking system
 This package provides the necessary infrastructure for basic TCP/IP based
 networking.
